package com.caimei.module.base.entity.po;

import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;

/**
 * cm_order
 *
 * @author
 */
@Data
public class CmOrder implements Serializable {
    private Long orderID;

    /**
     * 订单编号
     */
    private String orderNo;

    /**
     * 采美组织默认为null,具体对应cm_mall_organize表ID
     */
    private Integer organizeID;

    private Long userID;

    /**
     * 下单人
     */
    private Integer buyUserID;

    /**
     * 子订单ID
     */
    private String shopOrderIDs;

    /**
     * 0:个人自己下单 1:企业自己下单 2:员工帮会所下单 3:协销帮会所下单  4:后台下单 5:采美豆订单
     */
    private Integer orderSubmitType;

    /**
     * 订单类型 协销订单 0 普通订单 1
     */
    private Integer orderType;

    /**
     * 是否包含活动商品(受订单未支付自动关闭时间影响)  0 否 1 是
     */
    private String hasActProduct;

    /**
     * 订单自动关闭时间点单位毫秒(v5.0版本已废弃)
     */
    private BigDecimal autoCloseTimeMills;

    /**
     * 0待确认,11待收待发,12待收部发,13待收全发,21部收待发,22部收部发,23部收全发,31已收待发,32已收部发,33已收全发,4交易完成,5订单完成,6已关闭,7交易全退
     */
    private String status;

    /**
     * （收款买家）收款状态：1待收款、2部分收款、3已收款
     */
    private String receiptStatus;

    /**
     * (付款供应商)付款状态：1待付款、2部分付款、3已付款
     */
    private String payStatus;

    /**
     * 发货状态：1待发货、2部分发货、3已发货
     */
    private String sendOutStatus;

    /**
     * 退货退款类型：1部分退、2全部退
     */
    private String refundType;

    /**
     * 已支付成功次数统计(适用线上多笔付款用来确认当前是哪一笔)
     */
    private Integer paySuccessCounter;

    /**
     * 是否已支付 未支付0 已支付1
     */
    private String payFlag;

    /**
     * 是否能走线上支付 0可以 1不可以 只能线下
     */
    private String onlinePayFlag;

    /**
     * 商品总金额 （商品单价乘以数量，再加上税费）
     */
    private BigDecimal productTotalFee;

    /**
     * 小计金额 （商品折后单价乘以数量，再加上税费）
     */
    private BigDecimal orderTotalFee;

    /**
     * 订单总额（小计金额减去经理折扣后，再加上运费）
     */
    private BigDecimal payTotalFee;

    /**
     * 真实支付金额（订单总额减去抵扣的账户余额）
     */
    private BigDecimal payableAmount;

    /**
     * 余额支付金额
     */
    private BigDecimal balancePayFee;

    /**
     * 总优惠 自助下单活动优惠 协销下单price-折后单价
     */
    private BigDecimal preferential;

    /**
     * 经理折扣
     */
    private BigDecimal discountFee;

    private Long spID;

    private Long mainSpID;

    /**
     * 订单备注
     */
    private String note;

    /**
     * 会所ID
     */
    private Long clubID;

    /**
     * 会所扫描确认时间
     */
    private String clubScanTime;

    /**
     * 支付方式,（协销订单可能会存在多种进账方式用,隔开）（v5.0版本已废弃）
     */
    private String payWay;

    /**
     * 订单来源  1WWW 2 CRM 3APP[历史数据] 4客服 5外单 6星范等小程序
     */
    private String orderSource;

    /**
     * 订单取消时间
     */
    private String closeTime;

    /**
     * 订单确认时间
     */
    private String confirmTime;

    /**
     * 订单支付时间
     */
    private String payTime;

    /**
     * 订单提交时间
     */
    private String orderTime;

    /**
     * 购买总数
     */
    private Integer productCount;

    /**
     * 赠送总数  不计算价格
     */
    private Integer presentCount;

    /**
     * 库分期免息状态 0、免息 1、不免息[V5.0.0版本已废弃]
     */
    private String cooFreeFlag;

    /**
     * 库分期分期费率[V5.0.0版本已废弃]
     */
    private Integer cooFreeRate;

    /**
     * 库分期免息金额[V5.0.0版本已废弃]
     */
    private BigDecimal cooFreeAmount;

    /**
     * 是否开发票 没开发票 0 开个人发票 1 开企业发票2
     */
    private String invoiceFlag;

    /**
     * 订单确认标志，0否，1后台确认，2买家确认（适用协销订单并且1或2都算已确认订单，主动订单默认1为确认）
     */
    private String confirmFlag;

    /**
     * 条款ID
     */
    private Long clauseID;

    /**
     * 条款内容
     */
    private String clauseContent;

    /**
     * 条款名称
     */
    private String clauseName;

    /**
     * 更新时间
     */
    private String updateDate;

    /**
     * 免邮标志  运费：-1到付，0包邮，1需要运费,-2仪器到付其它包邮
     */
    private String freePostFlag;

    /**
     * -1到付，0包邮，大于0具体金额,-2仪器到付其它包邮（且运费已使用商品形式存储）
     */
    private BigDecimal freight;

    /**
     * 订单状态 0 有效  其它无效
     */
    private String delFlag;

    /**
     * 包邮券ID  保留字段
     */
    private Integer freePostageTicketID;

    /**
     * 订单是否可拆分   1可拆分 0不可拆分
     */
    private String splitFlag;

    /**
     * 订单取消原因
     */
    private String closeReason;

    /**
     * 邮费订单标识 1是邮费订单  0不是邮费订单
     */
    private String postageOrderFlag;

    /**
     * 第三方订单编号(绑定第三方订单关系),适用第三方发起订单
     */
    private String thirdPartyOrderNo;

    private static final long serialVersionUID = 1L;
}
